{
  This file was automatically generated on 2018-10-05.

  Delphi/Lazarus Bindings Version 2.1.21

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletRGBLEDMatrix;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_RGB_LED_MATRIX_DEVICE_IDENTIFIER = 272;
  BRICKLET_RGB_LED_MATRIX_DEVICE_DISPLAY_NAME = 'RGB LED Matrix Bricklet';

  BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_RED = 1;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_RED = 2;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_GREEN = 3;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_GREEN = 4;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_BLUE = 5;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_BLUE = 6;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_FRAME_DURATION = 7;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_FRAME_DURATION = 8;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_DRAW_FRAME = 9;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_SUPPLY_VOLTAGE = 10;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_RESET = 243;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_WRITE_UID = 248;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_READ_UID = 249;
  BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_RGB_LED_MATRIX_CALLBACK_FRAME_STARTED = 11;

  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_RGB_LED_MATRIX_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_RGB_LED_MATRIX_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_RGB_LED_MATRIX_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_RGB_LED_MATRIX_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_RGB_LED_MATRIX_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletRGBLEDMatrix = class;
  TBrickletRGBLEDMatrixNotifyFrameStarted = procedure(sender: TBrickletRGBLEDMatrix; const frameNumber: longword) of object;

  /// <summary>
  ///  RGB LED Matrix with 8x8 pixel
  /// </summary>
  TBrickletRGBLEDMatrix = class(TDevice)
  private
    frameStartedCallback: TBrickletRGBLEDMatrixNotifyFrameStarted;
  protected
    procedure CallbackWrapperFrameStarted(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Sets the 64 red LED values of the matrix.
    /// </summary>
    procedure SetRed(const red: array of byte); virtual;

    /// <summary>
    ///  Returns the red LED values as set by <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetRed"/>.
    /// </summary>
    function GetRed: TArray0To63OfUInt8; virtual;

    /// <summary>
    ///  Sets the 64 green LED values of the matrix.
    /// </summary>
    procedure SetGreen(const green: array of byte); virtual;

    /// <summary>
    ///  Returns the green LED values as set by <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetGreen"/>.
    /// </summary>
    function GetGreen: TArray0To63OfUInt8; virtual;

    /// <summary>
    ///  Sets the 64 blue LED values of the matrix.
    /// </summary>
    procedure SetBlue(const blue: array of byte); virtual;

    /// <summary>
    ///  Returns the blue LED values as set by <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetBlue"/>.
    /// </summary>
    function GetBlue: TArray0To63OfUInt8; virtual;

    /// <summary>
    ///  Sets the frame duration in ms.
    ///  
    ///  Example: If you want to achieve 20 frames per second, you should
    ///  set the frame duration to 50ms (50ms * 20 = 1 second).
    ///  
    ///  Set this value to 0 to turn the automatic frame write mechanism off.
    ///  
    ///  Approach:
    ///  
    ///  * Call <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetFrameDuration"/> with value &gt; 0.
    ///  * Set LED values for first frame with <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetRed"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetGreen"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetBlue"/>.
    ///  * Wait for <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.OnFrameStarted"/> callback.
    ///  * Set LED values for second frame with <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetRed"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetGreen"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetBlue"/>.
    ///  * Wait for <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.OnFrameStarted"/> callback.
    ///  * and so on.
    ///  
    ///  For frame duration of 0 see <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.DrawFrame"/>.
    ///  
    ///  Default value: 0 = off.
    /// </summary>
    procedure SetFrameDuration(const frameDuration: word); virtual;

    /// <summary>
    ///  Returns the frame duration in ms as set by <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetFrameDuration"/>.
    /// </summary>
    function GetFrameDuration: word; virtual;

    /// <summary>
    ///  If you set the frame duration to 0 (see <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetFrameDuration"/>), you can use this
    ///  function to transfer the frame to the matrix.
    ///  
    ///  Approach:
    ///  
    ///  * Call <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetFrameDuration"/> with 0.
    ///  * Set LED values for first frame with <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetRed"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetGreen"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetBlue"/>.
    ///  * Call <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.DrawFrame"/>.
    ///  * Wait for <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.OnFrameStarted"/> callback.
    ///  * Set LED values for second frame with <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetRed"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetGreen"/>, <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetBlue"/>.
    ///  * Call <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.DrawFrame"/>.
    ///  * Wait for <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.OnFrameStarted"/> callback.
    ///  * and so on.
    /// </summary>
    procedure DrawFrame; virtual;

    /// <summary>
    ///  Returns the current supply voltage of the Bricklet. The voltage is given in mV.
    /// </summary>
    function GetSupplyVoltage: word; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletRGBLEDMatrix.TBrickletRGBLEDMatrix.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature in °C as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered as soon as a new frame write is started.
    ///  The LED values are double buffered, so you can send the LED values
    ///  for the next frame directly after this callback is triggered.
    /// </summary>
    property OnFrameStarted: TBrickletRGBLEDMatrixNotifyFrameStarted read frameStartedCallback write frameStartedCallback;
  end;

implementation

constructor TBrickletRGBLEDMatrix.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_RED] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_RED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_GREEN] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_GREEN] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_BLUE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_BLUE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_FRAME_DURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_FRAME_DURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_DRAW_FRAME] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_SUPPLY_VOLTAGE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_RGB_LED_MATRIX_CALLBACK_FRAME_STARTED] := {$ifdef FPC}@{$endif}CallbackWrapperFrameStarted;
end;

procedure TBrickletRGBLEDMatrix.SetRed(const red: array of byte);
var request: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_RED, 72);
  if (Length(red) <> 64) then raise EInvalidParameterException.Create('Red has to be exactly 64 items long');
  for i := 0 to Length(red) - 1 do LEConvertUInt8To(red[i], 8 + (i * 1), request);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.GetRed: TArray0To63OfUInt8;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_RED, 8);
  response := SendRequest(request);
  for i := 0 to 63 do result[i] := LEConvertUInt8From(8 + (i * 1), response);
end;

procedure TBrickletRGBLEDMatrix.SetGreen(const green: array of byte);
var request: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_GREEN, 72);
  if (Length(green) <> 64) then raise EInvalidParameterException.Create('Green has to be exactly 64 items long');
  for i := 0 to Length(green) - 1 do LEConvertUInt8To(green[i], 8 + (i * 1), request);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.GetGreen: TArray0To63OfUInt8;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_GREEN, 8);
  response := SendRequest(request);
  for i := 0 to 63 do result[i] := LEConvertUInt8From(8 + (i * 1), response);
end;

procedure TBrickletRGBLEDMatrix.SetBlue(const blue: array of byte);
var request: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_BLUE, 72);
  if (Length(blue) <> 64) then raise EInvalidParameterException.Create('Blue has to be exactly 64 items long');
  for i := 0 to Length(blue) - 1 do LEConvertUInt8To(blue[i], 8 + (i * 1), request);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.GetBlue: TArray0To63OfUInt8;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_BLUE, 8);
  response := SendRequest(request);
  for i := 0 to 63 do result[i] := LEConvertUInt8From(8 + (i * 1), response);
end;

procedure TBrickletRGBLEDMatrix.SetFrameDuration(const frameDuration: word);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_FRAME_DURATION, 10);
  LEConvertUInt16To(frameDuration, 8, request);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.GetFrameDuration: word;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_FRAME_DURATION, 8);
  response := SendRequest(request);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletRGBLEDMatrix.DrawFrame;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_DRAW_FRAME, 8);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.GetSupplyVoltage: word;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_SUPPLY_VOLTAGE, 8);
  response := SendRequest(request);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletRGBLEDMatrix.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletRGBLEDMatrix.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRGBLEDMatrix.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRGBLEDMatrix.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRGBLEDMatrix.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRGBLEDMatrix.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletRGBLEDMatrix.Reset;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_RESET, 8);
  SendRequest(request);
end;

procedure TBrickletRGBLEDMatrix.WriteUID(const uid: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request);
end;

function TBrickletRGBLEDMatrix.ReadUID: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_READ_UID, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletRGBLEDMatrix.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_RGB_LED_MATRIX_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletRGBLEDMatrix.CallbackWrapperFrameStarted(const packet: TByteArray);
var frameNumber: longword;
begin
  frameNumber := LEConvertUInt32From(8, packet);

  if (Assigned(frameStartedCallback)) then begin
    frameStartedCallback(self, frameNumber);
  end;
end;

end.
